/*                                                           Pontificia Universidade Catolica
 *  Campinas - Sao Paulo - Brasil
 *  dez/2004
 *
 * 	Projeto Semestral - Sistemas Operacionais 2
 *
 *	Camada Independente de Dispositivos
 * 
 *	Desenvolvedor:  	Cesar Kallas		:RA 02099224	cesarkallas@gmx.net
 *					
 *	 NECESSARIO EXECUTAR O DRIVER ANTES
 *	ESSE NAO EH UM ARQUIVO DE TESTES
 * Ultima atualizacao: 09/12/2004
 */
	
#include "lib.h"

#define TAM_NOME_ARQUIVO		8
#define TAM_EXTENSAO_ARQUIVO	3
#define TAM_DATA	6
#define TAM_BLOCO	512
#define TAM_BUFFER	(2048*1024)
#define NUMERO_MAGICO	10

#define TIPO_FAT	12
#define TAM_TAB_FAT(TIPO_FAT) (TIPO_FAT == 8 ? 256 : TIPO_FAT == 10 ? 1024 : TIPO_FAT == 12 ? 4096 : 65536)
#define TAM_FAT(TIPO_FAT) (TAM_TAB_FAT(TIPO_FAT) * sizeof(int *))

#define TIPO_BFD		2
#define TIPO_ARQUIVO	1
#define TIPO_DIRETORIO	0

#define SOMENTE_LEITURA	0
#define SOMENTE_ESCRITA 1
#define LEITURA_ESCRITA 2
#define OCULTO		3

struct sembuf	down[1] = {0,-1,0};	// Estrutura para operacao de decremento do semaforo
struct sembuf	up[1] = {0,1,0};	// Estrutura para operacao de incremento do semaforo

#define SEM_LISTAAA	 0x9001		/* Chave do semafaro da listaaa */
key_t SHM_LISTAAA	= 0x9450;	/* Chave da Memoria Compartilhada da Lista de arquivos abertos  */
key_t SHM_PCB		= 0x5250;	/* Chave da Memoria Compartilhada da Lista de PCB  */


int shm_listaaa;	/* Identificacao da Memoria compartilhada Lista de arquivos abertos */
int shm_pcb;		/* Identificacao da Memoria compartilhada Lista de PCB */
int sem_listaaa;	// ID do Semaforo de Exclusao Mutua da Lista de arquivos abertos

// Estrutura da Lista de arquivos abertos global (para todos processos)
typedef struct
{
	int primeiro_bloco;		// primeiro bloco na fat
	int contador;
} LISTAAA;
LISTAAA *listaaa;
int listaaaid=0;

// Lista de descritores por processo
typedef struct
{
	int handler;
	char *buffer;				/* ponteiro para o buffer do arquivo, por nao ter implementacao do read e write, coloquei esse apenas para indicacao */
	int posicao_listaaa;
	int atributo;
	LISTAAA *listaaa;
} DESCRITOR;
int index_descritor=0;

// PCB do processo
typedef struct
{
	int pid;
	char diretorio_corrente[TAM_MAX_URL];
	DESCRITOR descritor[NUMERO_MAGICO];
} PCB;
PCB pcb;

int fat[TAM_TAB_FAT(TIPO_FAT)];

/* Funcao que retorna o tamanho de um string (qtde de caracteres) */
int tam(char *string)
{
	int i, size=0;
	
	for(i=0; ; i++)
	{
		if(!string[i])	/* se for final da string, pare de contar */
			break;
		size++;
	}
	return size;
}

/* Funcao que retorna 1 se o caminho eh valido, 0 se nao for valido (quanto a sua sintaxe) */
int validapath(char *cam)
{
	int i;
	
	if(!cam[0])
		return 0;
	
	//if(cam[0]=='/')
	//	return 0;
		
	for(i=0; i < tam(cam); i++)
	{
		if(cam[i]=='/' && cam[i+1]=='/')
		return 0;
		
		if(cam[i]=='/' && !cam[i+1])
		return 0;
	}
	return 1;
}

/* Funcao que retorna 1 se a string passada contem um diretorio no comeco do caminho 
Entenda-se como diretorio uma cadeia de char seguida por uma barra de 45graus /
exemplo: arquivos/teste.c
retorna 1 porque arquivos eh um diretorio
*/
int isdir(char *cam)
{
	int i;
	
	if(!cam[0])
	return 2;
	
	for(i=0; i < tam(cam); i++)
		if(cam[i]=='/')
			return 1;
	return 0;
}

/* Funcao que copia o diretorio c1 em c2 J caracteres a partir de 0 */
void cp(char *c1, char *c2, int j)
{
	int i;
	
	//if(tam(c1)<=tam(c2))
	for(i=0; j>=0; i++, j--)
	{
		//printf("\ni=%d j=%d", i, j);
		c2[i]=c1[i];
	}
	c2[i]='\0';
}

/* Funcao que remove de c1 J caracteres, a partir de 0 */
void rm(char *c1, int j)
{
	int i;
	char tmp[tam(c1)];
	
	for(i=0; j!=tam(c1); i++, j++)
	{
		tmp[i] = c1[j];
		//printf("\ni=%d j=%d tmp=%c", i, j, tmp[i]);
	}
	
	for(j=0; i>=0; i--, j++)
	{
		c1[j] = tmp[j];
	}
	c1[j-1] = '\0';
}
	
/* Funcao que retorna o proximo caminho a ser percorrido:
	Por exemplo: faculdade/teste/puc.c
	a funcao ira retornar "faculdade" como o sendo o proximo diretorio a ser percorrido
e ira retirar do caminho dado esse diretorio. Caso seja um arquivo, ele ira retirar do caminho o
nome desse arquivo e finalizara o caminho inicial passado pela camada do usuario
*/
void getpath(char *cam, char *temp)
{
	int i, j;
	//char temp[tam(cam)];
	
	if(validapath(cam))
	{
		for(i=0; i < tam(cam); i++)
		{
			if(cam[i]=='/' && i!=0)
			{
				cp(cam, temp, i-1);	// copia pra temp o que foi removido
				rm(cam, i+1);		// retira de cam o que foi removido
			//	printf("\ndentro cam barra");
			//	printf("\n i=%d temp=%s cam=%s\n", i, temp, cam);
				break;
			}
			if(!cam[i+1])
			{
				cp(cam, temp, i);
				cam[0]='\0';
			//	printf("\n dentro cam null");
			//	printf("\n i=%d temp=%s cam=%s\n", ++i, temp, cam);
				break;
			}
		}
	}
	//if(validapath(cam))
	//printf("\n\n\n%s", cam2);
}

// Depois de ser feita a chamada para o driver, o mesmo preenche uma memoria compartilhada com os dados
// da BFD, agora nessa funcao, cria-se a memoria compartilhada para se ter acesso aos dados colocados pelo driver
int consulta_bfd(int tam_bfd)
{
	// Cria memoria compartilhada do BFD
	if((shm_bfd = shmget(SHM_BFD,(tam_bfd*sizeof(BFD)),IPC_CREAT | 0666))==-1)
	{
		print("[cid.h:consulta_bfd] Erro ao criar a memoria compartilhada da BFD");
		return -2;
	}else
		print("[cid.h:consulta_bfd] Criado acesso ao BFD");
	
	// Inicia a memoria compartilhada do BFD
	if((bfd = (BFD *) shmat(shm_bfd, NULL, 0))==(BFD *) -1)
	{
		print("[cid.h:consulta_bfd] Erro ao iniciar a memoria compartilhada do BFD");
		return -2;
	}else
		print("[cid.h:consulta_bfd] Iniciado o acesso ao BFD");
	return 1;
}


// Essa funcao inicia a(s) memoria(s) compartilhada(s) e a(s) estrutura(s) necessiria(s) por exemplo semafaro
void start(void)
{
	// Cria memoria compartilhada da Lista de arquivos abertos
	if((shm_listaaa = shmget(SHM_LISTAAA,(NUMERO_MAGICO * sizeof(LISTAAA)),IPC_CREAT | 0666))==-1)
		print("[cid.h:start] Erro ao criar a memoria compartilhada da Lista de arquivos abertos");
	
	// Inicia a memoria compartilhada da Lista de arquivos abertos
	if((listaaa = (LISTAAA *) shmat(shm_listaaa, NULL, 0))==(LISTAAA *) -1)
		print("[cid.h:start] Erro ao iniciar a memoria compartilhada da Lista de arquivos abertos");
	
	// Cria Semafaro da Lista de arquivos abertos
	if((sem_listaaa = semget(SEM_LISTAAA, 1, 0666 |IPC_CREAT))==-1)
		print("[cid.h:start] Erro ao criar o semafaro da Lista de arquivos abertos");
	
	// Cria fila de mensagem que ira comunicar com o driver
	if( (msg_cid = msgget(MSG_CID, IPC_CREAT | 0666)) == -1 )
		print("[cid.h:start] Impossivel criar fila de mensagem");
	else
		print("[cid.h:start] Fila de mensagem criada");
	
	// Cria memoria compartilhada do BUFFER
	if((shm_buffer = shmget(SHM_BUFFER,(NUMERO_MAGICO * sizeof(BUFFER)),IPC_CREAT | 0666))==-1)
		print("[cid.h:start] Erro ao criar a memoria compartilhada do BUFFER");
	
	// Inicia a memoria compartilhada do BUFFER
	if((buffer = (BUFFER *) shmat(shm_buffer, NULL, 0))==(BUFFER *) -1)
		print("[cid.h:start] Erro ao iniciar a memoria compartilhada do BUFFER");

	pcb.pid = getpid();
	strcpy(pcb.diretorio_corrente, "/Windows");
}

void stop(void)
{	stop();
	if( shmctl(shm_listaaa,IPC_RMID,NULL) != 0 )
		print("[cid.h:stop] Impossivel remover a memoria compartilhada Listaaa");
	else
		print("[cid.h:stop] Removendo a memoria compartilhada Listaaa");
	
	if(shmctl(shm_buffer,IPC_RMID,NULL) != 0 )
		print("[cid.h:stop] Impossivel remover a memoria compartilhada BUFFER");
	else
		print("[cid.h:stop] Removendo a memoria compartilhada BUFFER");
	
	if(shmctl(shm_bfd,IPC_RMID,NULL) != 0 )
		print("[cid.h:stop] Impossivel remover a memoria compartilhada bfd");
	else
		print("[cid.h:stop] Removendo a memoria compartilhada bfd");
	
	if( semctl( sem_listaaa, 0, IPC_RMID, 0) != 0 )
		print("[cid.h:stop] Impossivel remover o semaforo da listaaa");
	else
		print("[cid.h:stop] Removendo o semaforo da listaaa");
	
}

// Envia requisicao ao driver atraves de uma fila de mensagem
int envia_requisicao_driver(int operacao, int index, int __buffer)
{
	requisicao->operacao = operacao;
	requisicao->index = index;
	requisicao->id_share_bloco = __buffer;
	requisicao->pid = getpid();
	
	buffer_requisicao.mtype=1;
	
	if( msgsnd(msg_cid,(struct msgbuf *)&buffer_requisicao, sizeof(REQUISICAO),0) ==-1 )
	{
		print("[cid.h:envia_requisica_driver] Impossivel enviar mensagem de requisicao ao driver");
		return -3;	// erro ao enviar mensagem (possivelmente fila nao criada)
	}else
		print("[cid.h:envia_requisica_driver] Enviada a requisicao ao driver");
	
	return 1;
}

int recebe_resposta_driver(void)
{
	
	if(msgrcv(msg_cid,(struct msgbuf *)&buffer_resposta,sizeof(RESPOSTA),1,0) == -1 )
	{
		print("[cid.h:ffopen] Impossivel receber mensagem de resposta do driver");
		return -3;	// erro de comunicao com o driver
	}else
	{
		prints("[cid.h:ffopen] Resposta do driver: ");
		printi(resposta->status);
		prints("\n");
	}
	return 1;
}

int ffopen(char *filename, int mode)
{
	int descritor=0;
	int i;
	int flag=0;
	int bloco_atual;
	char temp[100];
	int tam_bfd;
	
	// Verifica se o caminho passado  vlido quanto a sua sintaxe (nao possuir duas barras por exemplo
	if(validapath(filename)!=1 && validapath(pcb.diretorio_corrente)!=1)
	{
		print("[cid:ffopen] Caminho invalido\n");
		return -1;
	}
	
	// Cria as estruturas [memorias compartilhadas; fila de mensagem; semafaro]
	start();
	
	// Verifica se o caminho e' relativo ou absoluto. Se for relativo (nao comeca com a /), 
	// junta-se o caminho passado com o diretorio corrente do pcb
	if( filename[0] == '/' )
	{
		prints("[cid.h:ffopen] Caminho absoluto: ");
		prints(filename);
		prints("\n");
	}else
	{
		print("[cid.h:ffopen] Caminho relativo, juntando caminhos");
		prints("[cid.h:ffopen] Diretorio relativo: ");
		prints(filename);
		prints("\n[cid.h:ffopen] Diretorio corrente: ");
		prints(pcb.diretorio_corrente);
		char temp[TAM_MAX_URL];
		strcpy(temp, pcb.diretorio_corrente);
		strcat(temp, "/");
		strcat(temp, filename);
		strcpy(filename, temp);
		prints("\n[cid.h:ffopen] Caminho total: ");
		prints(filename);
		prints("\n");
	}
	
	// Remove a barra que indica a raiz do caminho
	// Nao precisa dela, porque a partir de agora, todos caminhos sao absolutos
	rm(filename, 1);
	
	// Requisicao para o driver da BFD, a operacao=1 significa para o driver que esta requerendo o BFD
	if(envia_requisicao_driver(1, 0, SHM_BUFFER)!=1) // consultar bloco bfd, esse 1 que esta agora eh pra teste apenas
		return -3;	// erro de comunicao com o driver

	// Resposta do driver sobre a requisicao do BFD
	if(recebe_resposta_driver()!=1)
		return -3; // erro de comunicao com o driver
	else
	{
		if(resposta->status < 1)
		{
			print("cid.h:ffopen] Nao foi possivel acessar o BFD");
			return -4;	// Erro ao acessar o BFD, nao existe, etc
		}
		
		// BFD  acessada e preenchiada pelo driver, agora a CID acessa ela
		// Cria o acesso ao BFD (memoria compartilhada)
		if(consulta_bfd(resposta->status)!=1)
			return -2;	// erro de acesso a estrtuturas (memorias compartilhadas, semafaro)
		
		tam_bfd = resposta->status;
		
		// Imprime BFD
		#ifdef PRINT
		for(i=0; i<resposta->status; i++)
		{
			prints("[cid.h:ffopen]\t\t");
			printi(bfd[i].tipo);
			prints("\t");
			printi(bfd[i].primeiro_bloco);
			prints("\n");
		}
		#endif
	}
	
	// Consulta endereco do bloco raiz (primeiro bloco apos o BFD)
	for(i=0; i<(resposta->status); i++)
	{
		if(bfd[i].tipo == TIPO_BFD)
			bloco_atual = bfd[++i].primeiro_bloco;
		prints("[cid.h:ffopen] Bloco raiz: ");
		printi(bloco_atual);
		prints("\n");
		break;
	}
	
	// A partir de agora comeca a busca pelos blocos dos arquivos, a partiir da raiz (bloco atual)
	while(1)
	{
		// Requisicao para o driver dos proximos blocos
		if(envia_requisicao_driver(2, bloco_atual, SHM_BUFFER)!=1)
			return -3;	// erro de comunicao com o driver
		
		if(recebe_resposta_driver()!=1)
			return -3; // erro de comunicao com o driver
		else
		{	// Resposta do driver
			if(resposta->status < 1)
			{
				print("cid.h:ffopen] Nao foi possivel acessar o bloco: ");
				printi(bloco_atual);
				return -4;	// Erro ao acessar o BFD, nao existe, etc
			} // Retornou dados, vamos imprimi-los
			#ifdef PRINT
			for(i=0; i<(resposta->status); i++)
			{
				prints("[cid.h:ffopen]\t");
				printi(buffer[i].index);
				prints("\t");
				prints(buffer[i].nome);
				prints("\n");
			}
			#endif
			
			// Pega  token a ser pesquisado pelo driver
			getpath(filename, temp);
			
			// Pesquisa se o token esta no bloco requerido, se estiver imprima que encontrou
			for(i=0; i<(resposta->status); i++)
			{
				if(strstr(temp, buffer[i].nome))
				{
					prints("[cid.h:ffopen] Encontrada entrada: ");
					prints(buffer[i].nome);
					prints("\tIndex na bfd: ");
					printi(buffer[i].index);
					prints("\n");
					flag=1;		// Encontrou entrada, agora podemos buscar o proximo bloco no bfd
					break;
				}
			}
			
			// Entrada de arquivodiretorio encontrada, pega o proximo bloco  de pesquisa no bfd e imprime
			if(flag==1)
			{
				bloco_atual = bfd[buffer[i].index-1].primeiro_bloco;
				prints("[cid.h:ffopen] Proximo bloco: ");
				printi(bloco_atual);
				prints("\n");
			}else
			{
				print("[cid.h:ffopen] Arquivo nao encontrado");
				return -1;	// Arquivo nao existe
			}			
			
			// Se o token a ser pesquisado agora for um arquivo, quer dizer que nao precisa mais pesquisar, intao
			// imprima que ja achou o arquivo (filename nao tera mais conteudo, porque os tokens vao sendo retirados desse caminho(filename))
			if(!filename[0])
			{
				prints("[cid.h:ffopen] Achei o arquivo [");
				prints(temp);
				prints("] primeiro bloco: ");
				printi(bloco_atual);
				prints("\n");
				flag=0;
				break;
			}
		}
	}
	
	// OK, arquivo existe, tenho primeiro bloco em maos, agora preencher tabela de arquivos abertos e lista de descritores
	// Pesquiso a listaaa pra ver se o arquivo ja esta aberto, se sim, eu adciono uma entrada na lista de descritores e aumento o contatdor
	// da listaaa em 1
	for(i=0; i<NUMERO_MAGICO; i++)
	{
		if(listaaa[i].primeiro_bloco == bloco_atual)
		{
			if(index_descritor==NUMERO_MAGICO)
				return -5;		// Lista de descritores cheia :p
			semop(sem_listaaa, down, 1);
			print("[cid.h:ffopen] Arquivo ja esta aberto");
			listaaa[i].contador++;
			flag=1;				// Entrada encontrada na listaaaa
			semop(sem_listaaa, up, 1);
			
			char bufferarquivo[4096];
			pcb.descritor[index_descritor].listaaa = listaaa;
			pcb.descritor[index_descritor].buffer  = bufferarquivo;
			pcb.descritor[index_descritor].atributo  = mode;
			pcb.descritor[index_descritor].handler  = i;
			descritor=index_descritor;
			index_descritor++;
			break;
		}
	}
	
	// Se nao for encontrada entrada na listaaa, adciono uma nova entrada
	if(flag==0)
	{
		semop(sem_listaaa, down, 1);
		//listaaa[listaaaid].tipo = bfd[bloco_atual].tipo;
		listaaa[listaaaid].primeiro_bloco = bloco_atual;
		listaaa[listaaaid].contador=1;
		listaaaid++;
		semop(sem_listaaa, up, 1);
	}else
		return -5;		// Lista de descritores cheia 

	// Imprimir tabela de arquivos abertos
	for(i=0; i<=listaaaid; i++)
	{
		print("[cid.h:ffopen] Tabela de arquivos abertos");
		prints("-----------------------------------------\n");
		prints("Indice  \tPrimeiro Bloco\tContador\n");
		printi(i);
		prints("\t\t");
		printi(listaaa[i].primeiro_bloco);
		prints("\t\t");
		printi(listaaa[i].contador);
		prints("\n");
	}
	
	// Apaga todas estruturas criadas
	//stop();

	return descritor; //  descritor handler na tabela de arquivos abertos do processo
		
}
